#include "stdafx.h"
#include "tinyxml2/tinyxml2.h"
#include "LuaCfgHelper.h"
#include <iostream>
#include <boost/algorithm/string.hpp>
#include "M_LuckTurnCFG.h"
std::auto_ptr<M_LuckTurnCFG> M_LuckTurnCFG::msSingleton(nullptr);

int M_LuckTurnCFG::GetCount()
{
	return (int)mMapData.size();
}

const M_LuckTurnCFGData* M_LuckTurnCFG::GetData(int ID)
{
	auto it = mMapData.find(ID);
	if (it != mMapData.end())
	{
		return &it->second;
	}
	return NULL;
}

const std::map<int, M_LuckTurnCFGData>& M_LuckTurnCFG::GetMapData()
{
	return mMapData;
}

void M_LuckTurnCFG::Load()
{
	tinyxml2::XMLDocument xmlDoc;
	std::string content = FileUtils::getInstance()->getStringFromFile("Config/M_LuckTurnCFG.xml");
	auto result = xmlDoc.Parse(content.c_str(), content.length());
	if (result != tinyxml2::XML_SUCCESS)
	{
		CCLOGERROR("Result:%d", result);
		CCASSERT(false, "result != tinyxml2::XML_SUCCESS");
		return;
	}
	auto root = xmlDoc.RootElement();
	if (root == NULL)
	{
		CCASSERT(false, "root == NULL");
		return;
	}
	auto element = root->FirstChildElement("Data");
	while (element != NULL)
	{
		M_LuckTurnCFGData data;
		data.mID = element->IntAttribute("ID");
		data.mItem = element->IntAttribute("Item");
		data.mCount = element->IntAttribute("Count");
		data.mWeight = element->IntAttribute("Weight");
		if (mMapData.find(data.mID) != mMapData.end())std::cout <<"data refind:" << data.mID << std::endl;
		CCASSERT(mMapData.find(data.mID) == mMapData.end(), "data.mID is exists");
		mMapData.insert(std::make_pair(data.mID, data));
		element = element->NextSiblingElement();
	}
	CCLOG("M_LuckTurnCFG Loaded. Load Data:%u", mMapData.size());
}

void M_LuckTurnCFG::LoadLua()
{
	LuaEngine::getInstance()->executeScriptFile("config/M_LuckTurnCFG");
	lua_State* L = LuaEngine::getInstance()->getLuaStack()->getLuaState();
	lua_getglobal(L, "M_LuckTurnCFG");
	CCASSERT(lua_istable(L, -1) == 1, "is not table");
	lua_pushstring(L, "datas");
	lua_gettable(L, -2);
	CCASSERT(lua_istable(L, -1) == 1, "is not table");
	lua_pushnil(L);
	while(lua_next(L, 2))
	{
		CCASSERT(lua_istable(L, -1) == 1, "is not table");
		M_LuckTurnCFGData data;
		LuaCfgHelper::readInt(L, "ID", data.mID);
		LuaCfgHelper::readInt(L, "Item", data.mItem);
		LuaCfgHelper::readInt(L, "Count", data.mCount);
		LuaCfgHelper::readInt(L, "Weight", data.mWeight);
		if (mMapData.find(data.mID) != mMapData.end())std::cout <<"data refind:" << data.mID << std::endl;
		CCASSERT(mMapData.find(data.mID) == mMapData.end(), "data.mID is exists");
		mMapData.insert(std::make_pair(data.mID, data));
		lua_pop(L, 1);
	}
	lua_settop(L, 0);
	CCLOG("M_LuckTurnCFG Loaded. Load Data:%u", mMapData.size());
}

void M_LuckTurnCFG::Reload()
{
	mMapData.clear();
	Load();
}

M_LuckTurnCFG* M_LuckTurnCFG::GetSingleton()
{
	if (msSingleton.get() == nullptr)
	{
		msSingleton.reset(new M_LuckTurnCFG());
	}
	return msSingleton.get();
}

void M_LuckTurnCFG::Release()
{
	msSingleton.reset(nullptr);
}
